<?php

class ControllerPaymentPayanyway extends Controller
{
    protected function index()
    {
        $this->data['button_confirm'] = $this->language->get('button_confirm');

        $this->data['continue'] = $this->url->link('checkout/success');

        $this->load->model('checkout/order');
        $order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);

        $mnt_id = $this->config->get('payanyway_mnt_id');
        $order_id = $this->session->data['order_id'];
        $currency = $this->config->get('payanyway_mnt_currency_code');
        $mnt_test_mode = $this->config->get('payanyway_mnt_test_mode');
        $mnt_dataintegrity_code = $this->config->get('payanyway_mnt_dataintegrity_code');

        $amount = $this->currency->format($order_info['total'], $currency, '', false);
        $amount = number_format($amount, 2, '.', '');
        $signature = md5("{$mnt_id}{$order_id}{$amount}{$currency}{$mnt_test_mode}{$mnt_dataintegrity_code}");

        $this->data['action'] = "https://{$this->config->get('payanyway_mnt_server')}/assistant.htm";
        $this->data['mnt_id'] = $mnt_id;
        $this->data['order_id'] = $order_id;
        $this->data['currency'] = $currency;
        $this->data['amount'] = $amount;
        $this->data['mnt_signature'] = $signature;
        $this->data['mnt_test_mode'] = $mnt_test_mode;
        $this->data['paymentSystemUnitId'] = 0;
        $this->data['mnt_success_url'] = $this->url->link('payment/payanyway/success');
        $this->data['mnt_fail_url'] = $this->url->link('checkout/checkout', '', 'SSL');

        /* Pay link begin */
        $submodule = '';
        $this->language->load('payment/payanyway');
        $this->data['payLinkText'] = $this->language->get('paylink_text');
        $urlData = array(
            'MNT_ID' => $this->data['mnt_id'],
            'MNT_TRANSACTION_ID' => $this->data['order_id'],
            'MNT_CURRENCY_CODE' => $this->data['currency'],
            'MNT_AMOUNT' => $this->data['amount'],
            'MNT_TEST_MODE' => $this->data['mnt_test_mode'],
            'MNT_SIGNATURE' => $this->data['mnt_signature'],
            'paymentSystem.unitId' => $this->data['paymentSystemUnitId']
        );
        $this->data['payLink'] = $this->data['action'].'?'.http_build_query($urlData);
        $this->data['payLinkEnabled'] = $this->config->get('payanyway'.$submodule.'_paylink');
        if ($this->data['payLinkEnabled'] == '1')
        {
            $this->model_checkout_order->confirm($order_id, $this->config->get('payanyway'.$submodule.'_order_status_id'),
                $this->language->get('order_comment_1').'<a href="' . htmlspecialchars($this->data['payLink']) . '">'.
                $this->language->get('order_comment_2').'</a>', true);
        }
        /* Pay link end */

        if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/payment/payanyway.tpl')) {
            $this->template = $this->config->get('config_template') . '/template/payment/payanyway.tpl';
        } else {
            $this->template = 'default/template/payment/payanyway.tpl';
        }

        $this->render();
    }

    const paw_kassa_VAT0     = 1104;  // НДС 0%
    const paw_kassa_VAT10    = 1103;  // НДС 10%
    const paw_kassa_VAT18    = 1102;  // НДС 18%
    const paw_kassa_VATNOVAT = 1105;  // НДС не облагается
    const paw_kassa_VATWR10  = 1107;  // НДС с рассч. ставкой 10%
    const paw_kassa_VATWR18  = 1106;  // НДС с рассч. ставкой 18%

    private static function monetaPayURLResponse($mnt_id, $mnt_transaction_id, $mnt_data_integrity_code, $success = false,
        $repeatRequest = false, $echo = true, $die = true, $kassa_inventory = null, $kassa_customer = null, $kassa_delivery = null)
    {
        if ($success === true)
            $resultCode = '200';
        elseif ($repeatRequest === true)
            $resultCode = '402';
        else
            $resultCode = '500';
        $mnt_signature = md5($resultCode.$mnt_id.$mnt_transaction_id.$mnt_data_integrity_code);
        $response = '<?xml version="1.0" encoding="UTF-8" ?>'."\n";
        $response .= "<MNT_RESPONSE>\n";
        $response .= "<MNT_ID>{$mnt_id}</MNT_ID>\n";
        $response .= "<MNT_TRANSACTION_ID>{$mnt_transaction_id}</MNT_TRANSACTION_ID>\n";
        $response .= "<MNT_RESULT_CODE>{$resultCode}</MNT_RESULT_CODE>\n";
        $response .= "<MNT_SIGNATURE>{$mnt_signature}</MNT_SIGNATURE>\n";
        if (!empty($kassa_inventory) || !empty($kassa_customer) || !empty($kassa_delivery))
        {
            $response .= "<MNT_ATTRIBUTES>\n";
            foreach (array('INVENTORY' => $kassa_inventory, 'CUSTOMER' => $kassa_customer, 'DELIVERY' => $kassa_delivery) as $k => $v)
                if (!empty($v))
                    $response .= "<ATTRIBUTE><KEY>{$k}</KEY><VALUE>{$v}</VALUE></ATTRIBUTE>\n";
            $response .= "</MNT_ATTRIBUTES>\n";
        }
        $response .= "</MNT_RESPONSE>\n";
        if ($echo === true)
        {
            header("Content-type: application/xml");
            echo $response;
        }
        else
            return $response;
        if ($die === true)
            die;
        return '';
    }

    public function callback()
    {
        $mnt_dataintegrity_code = $this->config->get('payanyway_mnt_dataintegrity_code');
        if (isset($_REQUEST['MNT_ID']) && isset($_REQUEST['MNT_TRANSACTION_ID']) && isset($_REQUEST['MNT_OPERATION_ID'])
            && isset($_REQUEST['MNT_AMOUNT']) && isset($_REQUEST['MNT_CURRENCY_CODE']) && isset($_REQUEST['MNT_TEST_MODE'])
            && isset($_REQUEST['MNT_SIGNATURE'])
        ) {
            $MNT_SIGNATURE = md5("{$_REQUEST['MNT_ID']}{$_REQUEST['MNT_TRANSACTION_ID']}{$_REQUEST['MNT_OPERATION_ID']}{$_REQUEST['MNT_AMOUNT']}{$_REQUEST['MNT_CURRENCY_CODE']}{$_REQUEST['MNT_TEST_MODE']}" . $mnt_dataintegrity_code);

            if ($_REQUEST['MNT_SIGNATURE'] == $MNT_SIGNATURE) {
                $order_id = $_REQUEST['MNT_TRANSACTION_ID'];
                $this->load->model('checkout/order');
                $order_info = $this->model_checkout_order->getOrder($order_id);
                if ($order_info) {
                    $currency = $this->config->get('payanyway_mnt_currency_code');
                    $amount = $this->currency->format($order_info['total'], $currency, '', false);
                    $amount = number_format($amount, 2, '.', '');
                    if ($amount == $_REQUEST['MNT_AMOUNT']) {
                        $message = "MNT_ID = {$_REQUEST['MNT_ID']}; ";
                        $message .= "MNT_TRANSACTION_ID = {$_REQUEST['MNT_TRANSACTION_ID']}; ";
                        $message .= "MNT_OPERATION_ID = {$_REQUEST['MNT_OPERATION_ID']}; ";
                        $message .= "MNT_AMOUNT = {$_REQUEST['MNT_AMOUNT']}; ";
                        $message .= "MNT_CURRENCY_CODE = {$_REQUEST['MNT_CURRENCY_CODE']}; ";
                        $message .= "MNT_TEST_MODE = {$_REQUEST['MNT_TEST_MODE']}; ";
                        $message .= "MNT_SIGNATURE = {$_REQUEST['MNT_SIGNATURE']}; ";
                        $this->language->load('payment/payanyway');
                        if (!$order_info['order_status_id']) {
                            $this->model_checkout_order->confirm($order_id, $this->config->get('payanyway_payed_order_status_id'), $this->language->get('payment_complete'));
                        } else {
                            $this->model_checkout_order->update($order_id, $this->config->get('payanyway_payed_order_status_id'), $this->language->get('payment_complete'), true);
                        }
                        // begin of kassa.payanyway.ru code
                        $inventoryPositions = array();
                        $this->load->model('account/order');
						/** @var ModelAccountOrder $modelAccountOrder */
						$modelAccountOrder = $this->model_account_order;
                        $products = $modelAccountOrder->getOrderProducts($order_id);
						$orderTotals = $modelAccountOrder->getOrderTotals($order_id);
                        foreach ($products as $product)
                        {
                            $inventoryPositions[] = array(
                                'name' => trim(preg_replace("/&?[a-z0-9]+;/i", "", htmlspecialchars($product['name']))),
                                'price' => $product['price'],
                                'quantity' => $product['quantity'],
                                'vatTag' => self::paw_kassa_VATNOVAT,
                            );
                        }
                        $kassa_delivery = null;
						foreach ($orderTotals as $orderTotal)
							if ($orderTotal['code'] == 'shipping')
							{
                                $kassa_delivery = $orderTotal['value'];
								break;
							}
                        $kassa_inventory = json_encode($inventoryPositions);
                        self::monetaPayURLResponse($_REQUEST['MNT_ID'], $_REQUEST['MNT_TRANSACTION_ID'],
                            $mnt_dataintegrity_code, true, false, true, true, $kassa_inventory, $order_info['email'],
                            $kassa_delivery);                                                                   // 200
                        // end of kassa.payanyway.ru code
                    } else {
                        self::monetaPayURLResponse($_REQUEST['MNT_ID'], $_REQUEST['MNT_TRANSACTION_ID'],
                            $mnt_dataintegrity_code, false, false);                                             // 500
                    }
                } else {
                    self::monetaPayURLResponse($_REQUEST['MNT_ID'], $_REQUEST['MNT_TRANSACTION_ID'],
                        $mnt_dataintegrity_code, false, true);                                                  // 402
                }
            } else {
                self::monetaPayURLResponse($_REQUEST['MNT_ID'], $_REQUEST['MNT_TRANSACTION_ID'],
                    $mnt_dataintegrity_code, false, false);                                                     // 500
            }
        } else {
            self::monetaPayURLResponse($_REQUEST['MNT_ID'], $_REQUEST['MNT_TRANSACTION_ID'],
                $mnt_dataintegrity_code, false, false);                                                         // 500
        }
    }

    public function success()
    {
        $this->load->model('checkout/order');
        /* set pending status if not payed yet order will be confirmed otherway confirm will do nothing */
        $status = $this->config->get('payanyway_order_status_id');
        $this->model_checkout_order->confirm($_REQUEST['MNT_TRANSACTION_ID'], $status, 'Order confirmed');
        $this->redirect($this->url->link('checkout/success'));
    }

    public function check()
    {
        $this->load->model('checkout/order');
        $mnt_dataintegrity_code = $this->config->get('payanyway_mnt_dataintegrity_code');
        $result_code = 500;

        $mnt_command = isset($this->request->get['MNT_COMMAND']) ? $this->request->get['MNT_COMMAND'] : '';
        $mnt_id = isset($this->request->get['MNT_ID']) ? $this->request->get['MNT_ID'] : '';
        $mnt_transaction_id = isset($this->request->get['MNT_TRANSACTION_ID']) ? $this->request->get['MNT_TRANSACTION_ID'] : '';
        $mnt_operation_id = isset($this->request->get['MNT_OPERATION_ID']) ? $this->request->get['MNT_OPERATION_ID'] : '';
        $mnt_amount = isset($this->request->get['MNT_AMOUNT']) ? $this->request->get['MNT_AMOUNT'] : '';
        $mnt_currency_code = isset($this->request->get['MNT_CURRENCY_CODE']) ? $this->request->get['MNT_CURRENCY_CODE'] : '';
        $mnt_test_mode = isset($this->request->get['MNT_TEST_MODE']) ? $this->request->get['MNT_TEST_MODE'] : '';
        $signature = md5($mnt_command . $mnt_id . $mnt_transaction_id . $mnt_operation_id . $mnt_amount . $mnt_currency_code . $mnt_test_mode . $mnt_dataintegrity_code);

        $order = $this->model_checkout_order->getOrder($mnt_transaction_id);
        if (!$order || $order['order_status_id'] !== '0') {
            /* order does not exist or its already confirmed with some non zero status*/
            $result_code = 500;
        }
        if ($order['order_status_id'] == $this->config->get('payanyway_order_status_id') || $order['order_status_id'] == '0') {
            /* order is ready and waiting for payment */
            $result_code = 402;
        }
        if ($order['order_status_id'] == $this->config->get('payanyway_payed_order_status_id')) {
            /* order is already payed */
            $result_code = 200;
        }

        $signature = md5($result_code . $mnt_id . $mnt_transaction_id . $mnt_dataintegrity_code);
        $amount = $this->currency->format($order['total'], $order['currency_code'], $order['currency_value'], false);
        $amount = number_format($amount, 2, '.', '');

        header("Content-type: application/xml");
        echo "<?xml version=\"1.0\" encoding=\"UTF-8\"?>";
        echo "<MNT_RESPONSE>";
        echo "<MNT_ID>" . $mnt_id . "</MNT_ID>";
        echo "<MNT_TRANSACTION_ID>" . $mnt_transaction_id . "</MNT_TRANSACTION_ID>";
        echo "<MNT_RESULT_CODE>" . $result_code . "</MNT_RESULT_CODE>";
        echo "<MNT_AMOUNT>" . $amount . "</MNT_AMOUNT>";
        echo "<MNT_SIGNATURE>" . $signature . "</MNT_SIGNATURE>";
        echo "</MNT_RESPONSE>";
    }

    public function payment_page() {
        $this->language->load('payment/payanyway');

        if (isset($this->request->get['id'])) {
            $this->document->setTitle($this->language->get('order_title').' №'.$this->request->get['id']);
        } else {
            $this->document->setTitle($this->language->get('order_title'));
        }

        if (isset($this->request->get['id'])) {
            $this->load->model('checkout/order');
            $order_info = $this->model_checkout_order->getOrder($this->request->get['id']);

            $this->data['heading_title'] = $this->language->get('order_title').' №'.$this->request->get['id'];

            $this->data['breadcrumbs'] = array();

            $this->data['breadcrumbs'][] = array(
                'href'      => $this->url->link('common/home'),
                'text'      => $this->language->get('text_home'),
                'separator' => false
            );

            $this->data['breadcrumbs'][] = array(
                'href'      => $this->url->link('checkout/cart'),
                'text'      => $this->language->get('order_title'),
                'separator' => $this->language->get('text_separator')
            );

            if ($order_info['order_status_id'] == $this->config->get('payanyway_order_status_id')) {

                $mnt_id = $this->config->get('payanyway_mnt_id');
                $order_id = $this->request->get['id'];
                $currency = $this->config->get('payanyway_mnt_currency_code');
                $mnt_test_mode = $this->config->get('payanyway_mnt_test_mode');
                $mnt_dataintegrity_code = $this->config->get('payanyway_mnt_dataintegrity_code');

                $amount = $this->currency->format($order_info['total'], $currency, '', false);
                $amount = number_format($amount, 2, '.', '');
                $signature = md5("{$mnt_id}{$order_id}{$amount}{$currency}{$mnt_test_mode}{$mnt_dataintegrity_code}");

                $this->data['action'] = "https://{$this->config->get('payanyway_mnt_server')}/assistant.htm";
                $this->data['mnt_id'] = $mnt_id;
                $this->data['order_id'] = $order_id;
                $this->data['currency'] = $currency;
                $this->data['amount'] = $amount;
                $this->data['mnt_signature'] = $signature;
                $this->data['mnt_test_mode'] = $mnt_test_mode;
                $this->data['paymentSystemUnitId'] = 0;
                $this->data['mnt_success_url'] = $this->url->link('payment/payanyway/success');
                $this->data['mnt_fail_url'] = $this->url->link('checkout/checkout', '', 'SSL');
                $this->data['date'] = $order_info['date_added'];
            } elseif ($order_info['order_status_id'] == $this->config->get('payanyway_payed_order_status_id')) {
                $this->data['order_paid'] = $this->language->get('order_paid');
            } else {
                $this->data['order_error'] = $this->language->get('order_error');
            }
        } else {
            $this->data['heading_title'] = $this->language->get('order_title');

            $this->data['breadcrumbs'] = array();

            $this->data['breadcrumbs'][] = array(
                'href'      => $this->url->link('common/home'),
                'text'      => $this->language->get('text_home'),
                'separator' => false
            );

            $this->data['breadcrumbs'][] = array(
                'href'      => $this->url->link('checkout/cart'),
                'text'      => $this->language->get('order_title'),
                'separator' => $this->language->get('text_separator')
            );

            $this->data['order_error'] = $this->language->get('order_error');
        }

        $this->data['continue'] = $this->url->link('common/home');

        $this->children = array(
            'common/column_left',
            'common/column_right',
            'common/content_top',
            'common/content_bottom',
            'common/footer',
            'common/header'
        );

        if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/payment/payanyway_order.tpl')) {
            $this->template = $this->config->get('config_template') . '/template/payment/payanyway_order.tpl';
        } else {
            $this->template = 'default/template/payment/payanyway_order.tpl';
        }

        $this->response->setOutput($this->render());
    }

}

?>