<?php
class ControllerPaymentPayanywayPost extends Controller {
	protected function index() {
		$this->load->language('payment/payanyway_post');

    	$this->data['button_confirm'] = $this->language->get('button_confirm');

		$this->data['continue'] = $this->url->link('checkout/success');

		$this->load->model('checkout/order');
		$order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);

        $mnt_id = $this->config->get('payanyway_mnt_id');
        $order_id = $this->session->data['order_id'];
        $currency = $this->config->get('payanyway_mnt_currency_code');
        $mnt_test_mode = $this->config->get('payanyway_mnt_test_mode');
        $mnt_dataintegrity_code = $this->config->get('payanyway_mnt_dataintegrity_code');
		
        $amount = $this->currency->format($order_info['total'], $currency, '', false);
		$amount = number_format($amount, 2, '.', '');
        $signature = md5("{$mnt_id}{$order_id}{$amount}{$currency}{$mnt_test_mode}{$mnt_dataintegrity_code}");

		$this->data['action'] = "https://{$this->config->get('payanyway_mnt_server')}/assistant.htm";
		$this->data['mnt_id'] = $mnt_id;
		$this->data['order_id'] = $order_id;
		$this->data['currency'] = $currency;
		$this->data['amount'] = $amount;
		$this->data['mnt_signature'] = $signature;
		$this->data['mnt_test_mode'] = $mnt_test_mode;
		$this->data['paymentSystemUnitId'] = 1029;
		$this->data['paymentSystemAccountId'] = 15;
		$this->data['mnt_success_url'] = $this->url->link('payment/payanyway/success');
		$this->data['mnt_fail_url'] = $this->url->link('checkout/checkout', '', 'SSL');

		$this->data['entry_additionalParameters'] = $this->language->get('entry_additionalParameters');
		$this->data['entry_mailofrussiaSenderIndex'] = $this->language->get('entry_mailofrussiaSenderIndex');
		$this->data['entry_mailofrussiaSenderRegion'] = $this->language->get('entry_mailofrussiaSenderRegion');
		$this->data['entry_mailofrussiaSenderAddress'] = $this->language->get('entry_mailofrussiaSenderAddress');
		$this->data['entry_mailofrussiaSenderName'] = $this->language->get('entry_mailofrussiaSenderName');
		$this->data['entry_mailofrussiaError'] = $this->language->get('entry_mailofrussiaError');

		if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/payment/payanyway_post.tpl')) {
			$this->template = $this->config->get('config_template') . '/template/payment/payanyway_post.tpl';
		} else {
			$this->template = 'default/template/payment/payanyway_post.tpl';
		}	
		
		$this->render();
	}
	
}
?>